import type { InjectionKey } from 'vue-demi';
import type { ModuleLoader, ModuleLoaderOptions, RegistrableModule, Lifecycles, Router, ErrorHandler } from './types';
/**
 * inject key
 */
export declare const ModuleLoaderSymbol: InjectionKey<ModuleLoader>;
/**
 * Set or unset active fetch, Used in SSR and internally when calling
 * actions and getters
 * @param loader ModuleLoader instance
 */
export declare const setActiveLoader: (loader: ModuleLoader | undefined) => ModuleLoader | undefined;
/**
 * Get the currently active fetch if there is any.
 */
export declare const getActiveLoader: () => ModuleLoader | undefined;
/**
 * ModuleLoader options
 */
export declare const moduleLoaderOptions: ModuleLoaderOptions;
/**
 * Set ModuleLoader options
 * @param options Options
 */
export declare function setModuleLoaderOptions(options: ModuleLoaderOptions): void;
/**
 * Error handlers
 */
export declare const errorHandlers: ErrorHandler[];
/**
 * Add error handler
 * @param handler Error handler
 */
export declare function addErrorHandler(handler: ErrorHandler): void;
/**
 * Remove error handler
 * @param handler Error handler
 */
export declare function removeErrorHandler(handler: ErrorHandler): void;
export declare function registerSubModules(modules: RegistrableModule | RegistrableModule[], lifecycles?: Lifecycles): (router?: Router) => Promise<void>;
export declare const componentLoader: (componentName: string, path: string, styles?: string | string[]) => Promise<import("vue-demi").Component<any, any, any, import("vue-demi").ComputedOptions, import("vue-demi").MethodOptions, {}, any>>;
