import { createModuleLoader } from './core/moduleLoader';
import { createComponentLoader } from './core/componentLoader';
var ModuleLoaderVuePlugin = /** @class */ (function () {
    function ModuleLoaderVuePlugin() {
    }
    ModuleLoaderVuePlugin.install = function (Vue) {
        // Used to avoid multiple mixins being setup
        // when in dev mode and hot module reload
        // https://github.com/vuejs/vue/issues/5089#issuecomment-284260111
        if (Vue.$__module_loader_installed__)
            return;
        // eslint-disable-next-line @typescript-eslint/camelcase
        Vue.$__module_loader_installed__ = true;
        this._moduleLoader = createModuleLoader(Vue);
        var componentLoader = (this._componentLoader = createComponentLoader(Vue));
        /**
         * 注入到 Vue 实例
         */
        Object.defineProperties(Vue.prototype, {
            $componentLoader: {
                value: componentLoader,
                writable: false,
                enumerable: true,
                configurable: true,
            },
        });
    };
    return ModuleLoaderVuePlugin;
}());
export { ModuleLoaderVuePlugin };
// Auto install if it is not done yet and `window` has `Vue`.
// To allow users to avoid auto-installation in some cases,
if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(ModuleLoaderVuePlugin);
}
