"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLoader = void 0;
var vue_demi_1 = require("vue-demi");
var moduleLoader_1 = require("./core/moduleLoader");
var componentLoader_1 = require("./core/componentLoader");
var register_1 = require("./register");
function createLoader() {
    var loader = (0, vue_demi_1.markRaw)({
        install: function (app) {
            // this allows calling registerSubModules() outside of a component setup after
            (0, register_1.setActiveLoader)(loader);
            if (!vue_demi_1.isVue2) {
                var moduleLoader = (0, moduleLoader_1.createModuleLoader)(app);
                var componentLoader = (0, componentLoader_1.createComponentLoader)(app);
                loader._a = app;
                loader._moduleLoader = moduleLoader;
                app.config.globalProperties.$componentLoader = loader._componentLoader = componentLoader;
                app.provide(register_1.ModuleLoaderSymbol, loader);
            }
        },
        setOptions: function (options) {
            register_1.setModuleLoaderOptions.call(null, options);
            return this;
        },
        addErrorHandler: function (handler) {
            register_1.addErrorHandler.call(null, handler);
            return this;
        },
        removeErrorHandler: function (handler) {
            register_1.removeErrorHandler.call(null, handler);
            return this;
        },
        // it's actually undefined here
        // @ts-expect-error set in install when using Vue 3
        _a: null,
    });
    return loader;
}
exports.createLoader = createLoader;
