"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModuleLoaderVuePlugin = void 0;
var moduleLoader_1 = require("./core/moduleLoader");
var componentLoader_1 = require("./core/componentLoader");
var ModuleLoaderVuePlugin = /** @class */ (function () {
    function ModuleLoaderVuePlugin() {
    }
    ModuleLoaderVuePlugin.install = function (Vue) {
        // Used to avoid multiple mixins being setup
        // when in dev mode and hot module reload
        // https://github.com/vuejs/vue/issues/5089#issuecomment-284260111
        if (Vue.$__module_loader_installed__)
            return;
        // eslint-disable-next-line @typescript-eslint/camelcase
        Vue.$__module_loader_installed__ = true;
        this._moduleLoader = (0, moduleLoader_1.createModuleLoader)(Vue);
        var componentLoader = (this._componentLoader = (0, componentLoader_1.createComponentLoader)(Vue));
        /**
         * 注入到 Vue 实例
         */
        Object.defineProperties(Vue.prototype, {
            $componentLoader: {
                value: componentLoader,
                writable: false,
                enumerable: true,
                configurable: true,
            },
        });
    };
    return ModuleLoaderVuePlugin;
}());
exports.ModuleLoaderVuePlugin = ModuleLoaderVuePlugin;
// Auto install if it is not done yet and `window` has `Vue`.
// To allow users to avoid auto-installation in some cases,
if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(ModuleLoaderVuePlugin);
}
